#ifndef CHATFORM_H
#define CHATFORM_H

#include <QWidget>

class KeyPressFilter;

namespace Ui {
	class ChatForm;
}

class ChatForm : public QWidget
{
	Q_OBJECT
public:
	ChatForm(QWidget *parent = 0);
	~ChatForm();

	void addMessage(const QString &message);

	void setJid(const QString &jid);
	QString jid() const;

protected:
	void changeEvent(QEvent *e);

private:
	Ui::ChatForm *ui;
	KeyPressFilter *mFilter;
	QString mJid;
	QString mDisplayName;

signals:
	void messageEntered(QString to, QString message);

private slots:
	void onReturnPressed();
};

inline void ChatForm::setJid(const QString &jid)
{
	mJid = jid;
}

inline QString ChatForm::jid() const
{
	return mJid;
}

#endif // CHATFORM_H
