#include "keypressfilter.h"
#include <QKeyEvent>

KeyPressFilter::KeyPressFilter(QObject *parent) :
	QObject(parent)
{
}

bool KeyPressFilter::eventFilter(QObject *obj, QEvent *e)
{
	if (e->type() == QEvent::KeyPress)
	{
		QKeyEvent *keyEv = static_cast<QKeyEvent *>(e);

		if ((keyEv->modifiers() == Qt::NoModifier) &&
			(keyEv->key() == Qt::Key_Enter || keyEv->key() == Qt::Key_Return))
		{
			emit returnPressed();
			return true;
		}
	}

	return QObject::eventFilter(obj, e);
 }
