#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QModelIndex>

class RosterItem;

namespace Ui {
	class MainWindow;
}

class XmppThread;
class QStandardItemModel;

class MainWindow : public QMainWindow
{
	Q_OBJECT
public:
	MainWindow(QWidget *parent = 0);
	~MainWindow();

private:
	void showChatForm(RosterItem *item);
	void closeAllChatForms();
	RosterItem* getRosterItemByJid(const QString &jid);

protected:
	void changeEvent(QEvent *e);
	void closeEvent(QCloseEvent *e);

private:
	Ui::MainWindow *ui;
	XmppThread *mThread;
	QStandardItemModel *mModel;
	QStringList mDomains;
	QStringList mServers;

private slots:
	void on_comboBox_Status_currentIndexChanged(int index);
	void on_listView_doubleClicked(const QModelIndex &index);
	void on_pushButton_clicked();
	void on_actionAboutQt_triggered();
	void on_actionAbout_triggered();

	// Manually added slots
	void on_xmppThread_finished();
	void onAuthSuccessful();
	void onAuthFailed();
	void onRosterItemReceived(QString jid, QString name);
	void onStatusReceived(QString from, QString status, QString message);
	void onMessageReceived(QString from, QString message);
};

#endif // MAINWINDOW_H
