#include "rosteritem.h"

RosterItem::RosterItem(const QString &jid) :
	mJid(jid),
	mForm(NULL)
{
	initialize();
}

RosterItem::RosterItem(const QString &jid, const QString &name) :
	mJid(jid),
	mName(name),
	mForm(NULL)
{
	initialize();
}

void RosterItem::setStatus(const QString &status, const QString &msg)
{
	mStatusMsg = msg;

	if (status == "unavailable")
	{
		mStatus = 0;
		setIcon(QIcon(":res/offline.png"));
	}
	else if (status == "available")
	{
		mStatus = 3;
		setIcon(QIcon(":res/online.png"));
	}
	else if (status == "away" || status == "xa")
	{
		mStatus = 2;
		setIcon(QIcon(":res/away.png"));
	}
	else if (status == "dnd")
	{
		mStatus = 1;
		setIcon(QIcon(":res/busy.png"));
	}
}

bool RosterItem::operator<(const QStandardItem &other) const
{
	const RosterItem &item = static_cast<const RosterItem &>(other);

	if (mStatus > item.mStatus)
	{
		return true;
	}
	else if (mStatus < item.mStatus)
	{
		return false;
	}
	else
	{
		return QStandardItem::operator<(other);
	}
}

void RosterItem::initialize()
{
	setSizeHint(QSize(0, 32));

	if (mName.length() > 0)
		setText(mName);
	else
		setText(mJid);

	setStatus("unavailable", "");
}
