#ifndef ROSTERITEM_H
#define ROSTERITEM_H

#include <QStandardItem>

class ChatForm;

class RosterItem : public QStandardItem
{
public:
	RosterItem(const QString &jid);
	RosterItem(const QString &jid, const QString &name);

	QString jid() const;

	void setResource(const QString &resource);
	QString resource() const;

	void setForm(ChatForm *form);
	ChatForm* form();

	void setStatus(const QString &status, const QString &msg);

	virtual bool operator<(const QStandardItem &other) const;

private:
	void initialize();

private:
	QString mJid;
	QString mName;
	QString mResource;

	int mStatus;
	QString mStatusMsg;

	ChatForm *mForm;
};

// Inline functions

inline QString RosterItem::jid() const
{
	return mJid;
}

inline void RosterItem::setResource(const QString &resource)
{
	mResource = resource;
}

inline QString RosterItem::resource() const
{
	return mResource;
}

inline void RosterItem::setForm(ChatForm *form)
{
	mForm = form;
}

inline ChatForm* RosterItem::form()
{
	return mForm;
}

#endif // ROSTERITEM_H
