#ifndef XMLHANDLER_H
#define XMLHANDLER_H

#include <QXmlDefaultHandler>
#include <QVector>

class XmlElement;

class XmlHandler : public QObject, public QXmlDefaultHandler
{
	Q_OBJECT
public:
	XmlHandler();
	~XmlHandler();

	virtual bool startElement(const QString &namespaceURI,
							  const QString &localName,
							  const QString &qName,
							  const QXmlAttributes &atts);

	virtual bool endElement(const QString &namespaceURI,
							const QString &localName,
							const QString &qName);

	virtual bool characters(const QString &ch);

signals:
	void streamStarted(const XmlElement*);
	void streamEnded();
	void elementReady(const XmlElement*);

private:
	bool mRootElem;
	QVector<XmlElement*> mStack;
};

#endif // XMLHANDLER_H
