#include "xmppthread.h"
#include "xmppclient.h"

XmppThread::XmppThread(QObject *parent,
					   const QString &username,
					   const QString &domain,
					   const QString &password,
					   const QString &server) :
	QThread(parent),
	mUsername(username),
	mDomain(domain),
	mPassword(password),
	mServer(server)
{
}

XmppThread::~XmppThread()
{
}

void XmppThread::sendMessage(QString to, QString message)
{
	emit messageReadyToSend(to, message);
}

void XmppThread::sendStatus(QString status, QString message)
{
	emit statusReadyToSend(status, message);
}

void XmppThread::run()
{
	XmppClient client;

	connect(&client, SIGNAL(disconnected()), this, SLOT(quit()));
	connect(&client, SIGNAL(authSuccessful()), this, SIGNAL(authSuccessful()));
	connect(&client, SIGNAL(authFailed()), this, SIGNAL(authFailed()));
	connect(&client, SIGNAL(rosterItemReceived(QString,QString)), this, SIGNAL(rosterItemReceived(QString,QString)));
	connect(&client, SIGNAL(statusReceived(QString,QString,QString)), this, SIGNAL(statusReceived(QString,QString,QString)));
	connect(&client, SIGNAL(messageReceived(QString,QString)), this, SIGNAL(messageReceived(QString,QString)));
	connect(this, SIGNAL(messageReadyToSend(QString,QString)), &client, SLOT(sendMessage(QString,QString)));
	connect(this, SIGNAL(statusReadyToSend(QString,QString)), &client, SLOT(sendStatus(QString,QString)));

	client.connectToHost(mUsername, mDomain, mPassword, mServer, 5222);
	exec();
}
