#ifndef XMPPTHREAD_H
#define XMPPTHREAD_H

#include <QThread>

class XmppThread : public QThread
{
	Q_OBJECT
public:
	XmppThread(QObject *parent,
			   const QString &username,
			   const QString &domain,
			   const QString &password,
			   const QString &server);

	~XmppThread();

	virtual void run();

private:
	QString mUsername;
	QString mDomain;
	QString mPassword;
	QString mServer;

signals:
	void authSuccessful();
	void authFailed();
	void rosterItemReceived(QString jid, QString name);
	void statusReceived(QString from, QString status, QString message);
	void messageReceived(QString from, QString message);

	void messageReadyToSend(QString to, QString message);
	void statusReadyToSend(QString status, QString message);

public slots:
	void sendMessage(QString to, QString message);
	void sendStatus(QString status, QString message);
};

#endif // XMPPTHREAD_H
